VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Form1"
   ClientHeight    =   7320
   ClientLeft      =   45
   ClientTop       =   360
   ClientWidth     =   11550
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7320
   ScaleWidth      =   11550
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstDirectoryParts 
      Height          =   2010
      Left            =   6360
      TabIndex        =   15
      Top             =   5040
      Width           =   5055
   End
   Begin VB.ListBox lstProperties 
      Height          =   2790
      Left            =   6360
      TabIndex        =   13
      Top             =   1800
      Width           =   5055
   End
   Begin VB.OptionButton rdoBoth 
      Caption         =   "&Both"
      Height          =   375
      Left            =   8160
      Style           =   1  'Graphical
      TabIndex        =   11
      Top             =   720
      Width           =   975
   End
   Begin VB.OptionButton rdoDirectories 
      Caption         =   "&Directories"
      Height          =   375
      Left            =   7080
      Style           =   1  'Graphical
      TabIndex        =   10
      Top             =   720
      Width           =   975
   End
   Begin VB.OptionButton rdoFiles 
      Caption         =   "&Files"
      Height          =   375
      Left            =   6120
      Style           =   1  'Graphical
      TabIndex        =   9
      Top             =   720
      Width           =   855
   End
   Begin VB.CheckBox chkRecursive 
      Caption         =   "Recursi&ve"
      Height          =   375
      Left            =   3360
      TabIndex        =   8
      Top             =   720
      Width           =   1215
   End
   Begin VB.CheckBox chkDirParts 
      Caption         =   "Directory P&arts"
      Height          =   375
      Left            =   4680
      TabIndex        =   7
      Top             =   720
      Width           =   1335
   End
   Begin VB.TextBox txtPattern 
      Height          =   375
      Left            =   1320
      TabIndex        =   5
      Text            =   "*.*"
      Top             =   720
      Width           =   1935
   End
   Begin VB.ListBox lstFiles 
      Height          =   5325
      Left            =   120
      TabIndex        =   3
      Top             =   1800
      Width           =   6135
   End
   Begin VB.CommandButton btnSearch 
      Caption         =   "&Search"
      Height          =   375
      Left            =   10080
      TabIndex        =   2
      Top             =   600
      Width           =   1335
   End
   Begin VB.TextBox txtSearchRoot 
      Height          =   375
      Left            =   1320
      TabIndex        =   1
      Text            =   "."
      Top             =   240
      Width           =   10095
   End
   Begin VB.Label Label5 
      Caption         =   "Directory pa&rts:"
      Height          =   255
      Left            =   6360
      TabIndex        =   14
      Top             =   4680
      Width           =   1815
   End
   Begin VB.Label Label4 
      Caption         =   "P&roperties:"
      Height          =   255
      Left            =   6360
      TabIndex        =   12
      Top             =   1440
      Width           =   1575
   End
   Begin VB.Label Label3 
      Caption         =   "F&iles:"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1440
      Width           =   1335
   End
   Begin VB.Label Label2 
      Caption         =   "&Pattern:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   840
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "Search &root:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private g_index As Integer
Private g_entries As Collection

Private Sub btnSearch_Click()

    Dim fs As New RECLS_COMLib.FileSearch

    Dim searchRoot As String
    Dim pattern As String
    Dim flags As Long

    Dim srch As Object

    ' Reset the collection
    Set g_entries = New Collection
    g_index = 0

    searchRoot = txtSearchRoot.Text
    pattern = txtPattern.Text
    flags = 0

    If chkRecursive.Value Then
        flags = flags Or RECLS_FLAG.RECLS_F_RECURSIVE
    End If

    If chkDirParts.Value Then
        flags = flags Or RECLS_FLAG.RECLS_F_DIRECTORY_PARTS
    End If

    If rdoBoth.Value = True Then
        flags = flags Or RECLS_FLAG.RECLS_F_FILES
        flags = flags Or RECLS_FLAG.RECLS_F_DIRECTORIES
    ElseIf rdoDirectories = True Then
        flags = flags Or RECLS_FLAG.RECLS_F_DIRECTORIES
    ElseIf rdoFiles = True Then
        flags = flags Or RECLS_FLAG.RECLS_F_FILES
    Else
        flags = flags Or RECLS_FLAG.RECLS_F_FILES
    End If
    

    Set srch = fs.Search(searchRoot, pattern, flags)

    lstFiles.Clear
    lstProperties.Clear
    lstDirectoryParts.Clear
    For Each entry In srch
        lstFiles.AddItem (entry)
        lstFiles.ItemData(lstFiles.NewIndex) = g_index
        
        g_entries.Add entry, CStr(g_index)
        g_index = g_index + 1
    Next

End Sub

Private Sub Form_Load()

    chkRecursive.Value = 1
    rdoFiles.Value = True

End Sub

Private Sub lstFiles_Click()

    Dim entry As RECLS_COMLib.FileEntry
    Dim index As Integer
    Dim dirParts As Object

    index = lstFiles.ItemData(lstFiles.ListIndex)

    Set entry = g_entries.Item(CStr(index))

    ' Do the properties
    lstProperties.Clear
    lstProperties.AddItem ("Drive: " & entry.Drive)
    lstProperties.AddItem ("Directory: " & entry.Directory)
    lstProperties.AddItem ("DirectoryPath: " & entry.DirectoryPath)
    lstProperties.AddItem ("File: " & entry.File)
    lstProperties.AddItem ("ShortFile: " & entry.ShortFile)
    lstProperties.AddItem ("FileName: " & entry.FileName)
    lstProperties.AddItem ("FileExt: " & entry.FileExt)
    lstProperties.AddItem ("CreationTime: " & entry.CreationTime)
    lstProperties.AddItem ("ModificationTime: " & entry.ModificationTime)
    lstProperties.AddItem ("LastAccessTime: " & entry.LastAccessTime)
    lstProperties.AddItem ("LastStatusChangeTime: " & entry.LastStatusChangeTime)
    lstProperties.AddItem ("Size: " & entry.Size)

    ' Do the directory parts
    Set dirParts = entry.DirectoryParts

    lstDirectoryParts.Clear
    For Each dirPart In dirParts
        lstDirectoryParts.AddItem (dirPart)
    Next

End Sub
